function(){
  tabPanel("Check Data",
           #            wellPanel(fluidRow(column(1),
           #                               column(5,
           #                       h3("Data Summary", style = "text-align:center"),
           #                       fluidRow(uiOutput('check1'))),
           #                       column(1),
           #                       column(5, 
           #                       fluidRow(radioButtons("ND_method", "Select method for Non-Detects",
           #                                             c("Ignore Non-Detections - remove from data set"=1,
           #                                               "Set Non-Detections equal to zero"=2,
           #                                               "Set Non-Detections equal to the Limit of Detection"=3,
           #                                               "Set Non-Detections equal to the 1/2 times the Limit of Detection"=4)))))),
           tabsetPanel(type = "tabs",
                       tabPanel("Home",
                                wellPanel(fluidRow(column(1),
                                                   column(10,
                                                          h3("Data Summary", style = "text-align:center"),
                                                          fluidRow(uiOutput('check1'))),
                                                   column(1)),
                                          fluidRow(column(1),
                                                   column(10, uiOutput('home_date'))),
                                          fluidRow(column(12, h5("Web Query:", style = "text-align: center"))),
                                          fluidRow(column(12, uiOutput('home_query')))),
                                wellPanel(fluidRow(column(1),
                                                   column(10,
                                                          fluidRow(h3(" Please select a method to deal with Non-Detections", style = "text-align: center")),
                                                          fluidRow(radioButtons("ND_method", " ",
                                                                                c("Ignore Non-Detections - remove from data set"=1,
                                                                                  "Set Non-Detections equal to zero"=2,
                                                                                  "Set Non-Detections equal to the Limit of Detection"=3,
                                                                                  "Set Non-Detections equal to the 1/2 times the Limit of Detection"=4)))))),
                                wellPanel(fluidRow(h3("Available Data Sets", style = "text-align: center")),
                                          fluidRow(h4("All Data: "), h5("This table  displays all of the raw data records imported from the Water Quality Portal")),
                                          fluidRow(h4("Non Detects: "), h5("These are the records with values for the 'Result Detection Condition Text' field equal to 'Not Detected' or 'Present below Quantitation Limit'")),
                                          fluidRow(h4("W/O Units: "), h5("These data records have no data entered in either the 'Result Measure - Measure Unit Code' or the 
                                                                         'Quantitation Limit Measure - Measure Unit Code' fields.")),
                                          fluidRow(h4("W/O Methods: "), h5("There are 14 Activity Type Codes which do not require a sample to have a specified method.  These data records 
                                                                           do not match those 14 Activity Type Codes AND have no data entered in the 'Result Analytical Method - Method Identifier' field.")),
                                          fluidRow(h4("Duplicates: "), h5("These data records are duplicated within the imported data set. This means these records match all fields of 
                                                                          another record in the data set except for the 'Activity Type' and 'Activity ID' fields")),
                                          fluidRow(h4("Filtered Data: "), h5("The Filtered Dataset includes only results with units and methods. Duplicate records have been removed. 
                                                                             This is the data set passed to the map and table on the 'View Data' page.")),
                                          fluidRow(h4("Summary: "), h5("This table shows summary statistics of all unique combinations of station, media, characteristic, unit, and sample
                                                                       fraction.")))),
                       tabPanel("All Data",
                                fluidRow(
                                  h3("All Imported Data Records", style = "text-align: center")),
                                fluidRow(h4("This table  displays all of the raw data records imported from the Water Quality Portal", style = "text-align: center")),
                                fluidRow(column(5), column(2, downloadButton("Save_data1", "Save Data"))),
                                bsPopover("Save_data1", "Save Data", "Click to download a .tsv file containing the data being viewed.",
                                          "top", trigger = "hover", options = list(container = "body")),
                                br(),
                                fluidRow(DT::dataTableOutput("All_Data"))),
                       tabPanel("Non Detects",
                                fluidRow(
                                  h3("Data Records with Non Detections", style = "text-align: center")),
                                fluidRow(h4("These are the records with values for the 'Result Detection Condition Text' field equal to 
                                            'Not Detected' or 'Present below Quantitation Limit'", style = "text-align: center")),
                                fluidRow(column(5), column(2, downloadButton("Save_data2", "Save Data"))),
                                bsPopover("Save_data2", "Save Data", "Click to download a .tsv file containing the data being viewed.",
                                          "top", trigger = "hover", options = list(container = "body")),
                                br(),
                                fluidRow(DT::dataTableOutput("ND_Table"))),
                       tabPanel("W/O Units",
                                fluidRow(
                                  h3("Data Records without Units", style = "text-align: center")),
                                fluidRow(h4("These data records have no data entered in either the 'Result Measure - Measure Unit Code' or the 
                                            'Quantitation Limit Measure - Measure Unit Code' fields.", style = "text-align: center")),
                                fluidRow(column(5), column(2, downloadButton("Save_data3", "Save Data"))),
                                bsPopover("Save_data3", "Save Data", "Click to download a .tsv file containing the data being viewed.",
                                          "top", trigger = "hover", options = list(container = "body")),
                                br(),
                                fluidRow(DT::dataTableOutput("NO_UNITS"))),
                       tabPanel("W/O Methods",
                                fluidRow(
                                  h3("Data Records Without Methods", style = "text-align: center")),
                                fluidRow(h4("There are 14 Activity Type Codes which do not require a sample to have a specified method.  These data records 
        do not match those 14 Activity Type Codes AND have no data entered in the 'Result Analytical Method - Method Identifier' field.", style = "text-align: center")),
                                fluidRow(column(5), column(2, downloadButton("Save_data4", "Save Data"))),
                                bsPopover("Save_data4", "Save Data", "Click to download a .tsv file containing the data being viewed.",
                                          "top", trigger = "hover", options = list(container = "body")),
                                br(),
                                fluidRow(DT::dataTableOutput("NO_METH"))),
                       tabPanel("Duplicates",
                                fluidRow(
                                  h3("Duplicate Data Records", style = "text-align: center")),
                                fluidRow(h4("These data records are duplicated within the imported data set. This means these records match all fields of 
       another record in the data set except for the 'Activity Type' and 'Activity ID' fields", style = "text-align: center")),
                                fluidRow(column(5), column(2, downloadButton("Save_data5", "Save Data"))),
                                bsPopover("Save_data5", "Save Data", "Click to download a .tsv file containing the data being viewed.",
                                          "top", trigger = "hover", options = list(container = "body")),
                                br(),
                                fluidRow(DT::dataTableOutput("DUPS"))),
                       tabPanel("Filtered Data",
                                fluidRow(
                                  h3("Filtered Data Set", style = "text-align: center")),
                                fluidRow( h4(" The Filtered Dataset includes only results with units and methods. Duplicate records have been removed. 
                                 This is the data set passed to the map and table on the 'View Data' page.",
                                             style = "text-align: center")),
                                fluidRow(column(5), column(2, downloadButton("Save_data6", "Save Data"))),
                                bsPopover("Save_data6", "Save Data", "Click to download a .tsv file containing the data being viewed.",
                                          "top", trigger = "hover", options = list(container = "body")),
                                br(),
                                fluidRow(DT::dataTableOutput("Filtered"))),
                       tabPanel("Summary",
                                fluidRow(
                                  h3("Click the button below to run a summary of the data", style = "text-align: center")),
                                fluidRow(column(5), column(2,
                                                           actionButton("SUMMARY", "Summarize Data"))),
                                br(),
                                conditionalPanel("output.Summ_run == 'yes'",
                                                 fluidRow(h4(" This table shows summary statistics of all unique combinations of station, media, characteristic, unit, and sample
                                fraction.", style = "text-align: center")),
                                                 fluidRow(column(5), column(2, downloadButton("Save_Summary_Data", "Save Data"))),
                                                 bsPopover("Save_Summary_Data", "Save Data", "Click to download a .tsv file containing the data being viewed.",
                                                           "top", trigger = "hover", options = list(container = "body")),
                                                 br()),
                                fluidRow(DT::dataTableOutput("SUMMARIZED"))))
                       )}